var __defProp = Object.defineProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });

// src/code.tsx
import { useData } from "@jsx-email/render";
import mem from "p-memoize";
import { Suspense } from "react";
import { getHighlighter as getHighBro } from "shikiji";
import { Fragment, jsx } from "react/jsx-runtime";
var getHighlighter = mem(async (language, theme = "nord") => {
  const shiki = await getHighBro({
    langs: language ? [language] : [],
    themes: [theme]
  });
  return shiki;
});
var Renderer = /* @__PURE__ */ __name((props) => {
  const { children, language, style, theme = "nord", ...rest } = props;
  const highlighter = useData(props, () => getHighlighter(language, theme));
  const code = children;
  const html = highlighter.codeToHtml(code, { lang: language, theme });
  return /* @__PURE__ */ jsx(
    "div",
    {
      ...rest,
      "data-id": "@jsx-email/code",
      style,
      dangerouslySetInnerHTML: { __html: html }
    }
  );
}, "Renderer");
var Code = /* @__PURE__ */ __name(({ children, ...props }) => {
  if (typeof children !== "string")
    throw new Error("Code: component children must be of type string");
  return /* @__PURE__ */ jsx(Fragment, { children: /* @__PURE__ */ jsx(Suspense, { fallback: /* @__PURE__ */ jsx("div", { children: "waiting" }), children: /* @__PURE__ */ jsx(Renderer, { ...props, children }) }) });
}, "Code");
Code.displayName = "Code";
export {
  Code
};
//# sourceMappingURL=index.mjs.map